Index: palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- palm/trunk/SOURCE/data_output_module.f90	(revision 4146)
+++ palm/trunk/SOURCE/data_output_module.f90	(revision 4147)
@@ -370,367 +374,368 @@
 !> @todo Convert given values into selected output_type.
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_dim( file_name, dimension_name, output_type, bounds,        &
-                      values_int8, values_int16, values_int32, values_intwp, &
-                      values_real32, values_real64, values_realwp,           &
-                      mask ) RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  file_name       !< name of file
-   CHARACTER(LEN=*), INTENT(IN) ::  dimension_name  !< name of dimension
-   CHARACTER(LEN=*), INTENT(IN) ::  output_type     !< data type of dimension variable in output file
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_dim'  !< name of this routine
-
-   INTEGER ::  d             !< loop index
-   INTEGER ::  f             !< loop index
-   INTEGER ::  i             !< loop index
-   INTEGER ::  j             !< loop index
-   INTEGER ::  ndims         !< number of dimensions in file
-   INTEGER ::  return_value  !< return value
-
-   INTEGER,         DIMENSION(:), INTENT(IN)           ::  bounds         !< lower and upper bound of dimension variable
-   INTEGER(KIND=1), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int8    !< values of dimension
-   INTEGER(KIND=2), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int16   !< values of dimension
-   INTEGER(KIND=4), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int32   !< values of dimension
-   INTEGER(iwp),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_intwp   !< values of dimension
-
-   LOGICAL,         DIMENSION(:), INTENT(IN), OPTIONAL ::  mask           !< mask of dimesion
-
-   REAL(KIND=4),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_real32  !< values of dimension
-   REAL(KIND=8),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_real64  !< values of dimension
-   REAL(wp),        DIMENSION(:), INTENT(IN), OPTIONAL ::  values_realwp  !< values of dimension
-
-   TYPE(dimension_type)                            ::  dimension       !< new dimension
-   TYPE(dimension_type), DIMENSION(:), ALLOCATABLE ::  dimensions_tmp  !< temporary dimension list
-
-
-   return_value = 0
-
-   CALL internal_message( 'debug', routine_name //                    &
-                          ': define dimension ' //                    &
-                          '(dimension "' // TRIM( dimension_name ) // &
-                          '", file "' // TRIM( file_name ) // '")' )
-
-   dimension%name      = TRIM( dimension_name )
-   dimension%data_type = TRIM( output_type )
-
-   !-- Check dimension bounds and allocate dimension according to bounds
-   IF ( SIZE( bounds ) == 1 )  THEN
-
-      !-- Dimension has only lower bound, which means it changes its size
-      !-- during simulation.
-      !-- Set length to -1 as indicator.
-      dimension%bounds(:) = bounds(1)
-      dimension%length    = -1
-
-      IF ( PRESENT( mask ) )  THEN
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                      &
-                                ': unlimited dimensions cannot be masked ' // &
-                                '(dimension "' // TRIM( dimension_name ) //   &
-                                '", file "' // TRIM( file_name ) // '")!' )
-      ENDIF
-
-   ELSEIF ( SIZE( bounds ) == 2 )  THEN
-
-      dimension%bounds = bounds
-      dimension%length = bounds(2) - bounds(1) + 1
-
-      !-- Save dimension values
-      IF ( PRESENT( values_int8 ) )  THEN
-         ALLOCATE( dimension%values_int8(dimension%bounds(1):dimension%bounds(2)) )
-         IF ( SIZE( values_int8 ) == dimension%length )  THEN
-            dimension%values_int8 = values_int8
-         ELSEIF ( SIZE( values_int8 ) == 1 )  THEN
-            dimension%values_int8(:) = values_int8(1)
-         ELSE
-            return_value = 2
-         ENDIF
-      ELSEIF( PRESENT( values_int16 ) )  THEN
-         ALLOCATE( dimension%values_int16(dimension%bounds(1):dimension%bounds(2)) )
-         IF ( SIZE( values_int16 ) == dimension%length )  THEN
-            dimension%values_int16 = values_int16
-         ELSEIF ( SIZE( values_int16 ) == 1 )  THEN
-            dimension%values_int16(:) = values_int16(1)
-         ELSE
-            return_value = 2
-         ENDIF
-      ELSEIF( PRESENT( values_int32 ) )  THEN
-         ALLOCATE( dimension%values_int32(dimension%bounds(1):dimension%bounds(2)) )
-         IF ( SIZE( values_int32 ) == dimension%length )  THEN
-            dimension%values_int32 = values_int32
-         ELSEIF ( SIZE( values_int32 ) == 1 )  THEN
-            dimension%values_int32(:) = values_int32(1)
-         ELSE
-            return_value = 2
-         ENDIF
-      ELSEIF( PRESENT( values_intwp ) )  THEN
-         ALLOCATE( dimension%values_intwp(dimension%bounds(1):dimension%bounds(2)) )
-         IF ( SIZE( values_intwp ) == dimension%length )  THEN
-            dimension%values_intwp = values_intwp
-         ELSEIF ( SIZE( values_intwp ) == 1 )  THEN
-            dimension%values_intwp(:) = values_intwp(1)
-         ELSE
-            return_value = 2
-         ENDIF
-      ELSEIF( PRESENT( values_real32 ) )  THEN
-         ALLOCATE( dimension%values_real32(dimension%bounds(1):dimension%bounds(2)) )
-         IF ( SIZE( values_real32 ) == dimension%length )  THEN
-            dimension%values_real32 = values_real32
-         ELSEIF ( SIZE( values_real32 ) == 1 )  THEN
-            dimension%values_real32(:) = values_real32(1)
-         ELSE
-            return_value = 2
-         ENDIF
-      ELSEIF( PRESENT( values_real64 ) )  THEN
-         ALLOCATE( dimension%values_real64(dimension%bounds(1):dimension%bounds(2)) )
-         IF ( SIZE( values_real64 ) == dimension%length )  THEN
-            dimension%values_real64 = values_real64
-         ELSEIF ( SIZE( values_real64 ) == 1 )  THEN
-            dimension%values_real64(:) = values_real64(1)
-         ELSE
-            return_value = 2
-         ENDIF
-      ELSEIF( PRESENT( values_realwp ) )  THEN
-         ALLOCATE( dimension%values_realwp(dimension%bounds(1):dimension%bounds(2)) )
-         IF ( SIZE( values_realwp ) == dimension%length )  THEN
-            dimension%values_realwp = values_realwp
-         ELSEIF ( SIZE( values_realwp ) == 1 )  THEN
-            dimension%values_realwp(:) = values_realwp(1)
-         ELSE
-            return_value = 2
-         ENDIF
-      ELSE
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                    &
-                                ': no values given ' //                     &
-                                '(dimension "' // TRIM( dimension_name ) // &
-                                '", file "' // TRIM( file_name ) // '")!' )
-      ENDIF
-
-      IF ( return_value == 2 )  THEN
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                               &
-                                ': number of values and given bounds do not match ' // &
-                                '(dimension "' // TRIM( dimension_name ) //            &
-                                '", file "' // TRIM( file_name ) // '")!' )
-      ENDIF
-
-      !-- Initialize mask
-      IF ( PRESENT( mask )  .AND.  return_value == 0 )  THEN
-
-         IF ( dimension%length == SIZE( mask ) )  THEN
-
-            IF ( ALL( mask ) )  THEN
-
-               CALL internal_message( 'debug', routine_name //                              &
-                                      ': mask contains only TRUE values. Ignoring mask ' // &
-                                      '(dimension "' // TRIM( dimension_name ) //           &
-                                      '", file "' // TRIM( file_name ) // '")!' )
-
-            ELSE
-
-               dimension%is_masked = .TRUE.
-               dimension%length_mask = COUNT( mask )
-
-               ALLOCATE( dimension%mask(dimension%bounds(1):dimension%bounds(2)) )
-               ALLOCATE( dimension%masked_indices(0:dimension%length_mask-1) )
-
-               dimension%mask = mask
-
-               !-- Save masked positions and masked values
-               IF ( ALLOCATED( dimension%values_int8 ) )  THEN
-
-                  ALLOCATE( dimension%masked_values_int8(0:dimension%length_mask-1) )
-                  j = 0
-                  DO  i = dimension%bounds(1), dimension%bounds(2)
-                     IF ( dimension%mask(i) )  THEN
-                        dimension%masked_values_int8(j) = dimension%values_int8(i)
-                        dimension%masked_indices(j) = i
-                        j = j + 1
-                     ENDIF
-                  ENDDO
-
-               ELSEIF ( ALLOCATED( dimension%values_int16 ) )  THEN
-
-                  ALLOCATE( dimension%masked_values_int16(0:dimension%length_mask-1) )
-                  j = 0
-                  DO  i = dimension%bounds(1), dimension%bounds(2)
-                     IF ( dimension%mask(i) )  THEN
-                        dimension%masked_values_int16(j) = dimension%values_int16(i)
-                        dimension%masked_indices(j) = i
-                        j = j + 1
-                     ENDIF
-                  ENDDO
-
-               ELSEIF ( ALLOCATED( dimension%values_int32 ) )  THEN
-
-                  ALLOCATE( dimension%masked_values_int32(0:dimension%length_mask-1) )
-                  j = 0
-                  DO  i =dimension%bounds(1), dimension%bounds(2)
-                     IF ( dimension%mask(i) )  THEN
-                        dimension%masked_values_int32(j) = dimension%values_int32(i)
-                        dimension%masked_indices(j) = i
-                        j = j + 1
-                     ENDIF
-                  ENDDO
-
-               ELSEIF ( ALLOCATED( dimension%values_intwp ) )  THEN
-
-                  ALLOCATE( dimension%masked_values_intwp(0:dimension%length_mask-1) )
-                  j = 0
-                  DO  i = dimension%bounds(1), dimension%bounds(2)
-                     IF ( dimension%mask(i) )  THEN
-                        dimension%masked_values_intwp(j) = dimension%values_intwp(i)
-                        dimension%masked_indices(j) = i
-                        j = j + 1
-                     ENDIF
-                  ENDDO
-
-               ELSEIF ( ALLOCATED( dimension%values_real32 ) )  THEN
-
-                  ALLOCATE( dimension%masked_values_real32(0:dimension%length_mask-1) )
-                  j = 0
-                  DO  i = dimension%bounds(1), dimension%bounds(2)
-                     IF ( dimension%mask(i) )  THEN
-                        dimension%masked_values_real32(j) = dimension%values_real32(i)
-                        dimension%masked_indices(j) = i
-                        j = j + 1
-                     ENDIF
-                  ENDDO
-
-               ELSEIF ( ALLOCATED(dimension%values_real64) )  THEN
-
-                  ALLOCATE( dimension%masked_values_real64(0:dimension%length_mask-1) )
-                  j = 0
-                  DO  i = dimension%bounds(1), dimension%bounds(2)
-                     IF ( dimension%mask(i) )  THEN
-                        dimension%masked_values_real64(j) = dimension%values_real64(i)
-                        dimension%masked_indices(j) = i
-                        j = j + 1
-                     ENDIF
-                  ENDDO
-
-               ELSEIF ( ALLOCATED(dimension%values_realwp) )  THEN
-
-                  ALLOCATE( dimension%masked_values_realwp(0:dimension%length_mask-1) )
-                  j = 0
-                  DO  i = dimension%bounds(1), dimension%bounds(2)
-                     IF ( dimension%mask(i) )  THEN
-                        dimension%masked_values_realwp(j) = dimension%values_realwp(i)
-                        dimension%masked_indices(j) = i
-                        j = j + 1
-                     ENDIF
-                  ENDDO
-
-               ENDIF
-
-            ENDIF  ! if not all mask = true
-
-         ELSE
-            return_value = 1
-            CALL internal_message( 'error', routine_name //                           &
-                                   ': size of mask and given bounds do not match ' // &
-                                   '(dimension "' // TRIM( dimension_name ) //        &
-                                   '", file "' // TRIM( file_name ) // '")!' )
-         ENDIF
-
-      ENDIF
-
-   ELSE
-
-      return_value = 1
-      CALL internal_message( 'error', routine_name //                                       &
-                             ': at least one but no more than two bounds must be given ' // &
-                             '(dimension "' // TRIM( dimension_name ) //                    &
-                             '", file "' // TRIM( file_name ) // '")!' )
-
-   ENDIF
-
-   !-- Add dimension to database
-   IF ( return_value == 0 )  THEN
-
-      DO  f = 1, nfiles
-
-         IF ( TRIM( file_name ) == files(f)%name )  THEN
-
-            IF ( files(f)%is_init )  THEN
-
-               return_value = 1
-               CALL internal_message( 'error', routine_name //                      &
-                                      ': file already initialized. ' //             &
-                                      'No further dimension definition allowed ' // &
-                                      '(dimension "' // TRIM( dimension_name ) //   &
-                                      '", file "' // TRIM( file_name ) // '")!' )
-               EXIT
-
-            ELSEIF ( .NOT. ALLOCATED( files(f)%dimensions ) )  THEN
-
-               ndims = 1
-               ALLOCATE( files(f)%dimensions(ndims) )
-
-            ELSE
-
-               !-- Check if any variable of the same name as the new dimension is already defined
-               IF ( ALLOCATED( files(f)%variables ) )  THEN
-                  DO  i = 1, SIZE( files(f)%variables )
-                     IF ( files(f)%variables(i)%name == dimension%name )  THEN
-                        return_value = 1
-                        CALL internal_message( 'error', routine_name //                    &
-                                ': file already has a variable of this name defined. ' //  &
-                                'Defining a dimension of the same name is not allowed ' // &
-                                '(dimension "' // TRIM( dimension_name ) //                &
-                                '", file "' // TRIM( file_name ) // '")!' )
-                        EXIT
-                     ENDIF
-                  ENDDO
-               ENDIF
-
-               IF ( return_value == 0 )  THEN
-                  !-- Check if dimension already exists in file
-                  ndims = SIZE( files(f)%dimensions )
-
-                  DO  d = 1, ndims
-                     IF ( files(f)%dimensions(d)%name == dimension%name )  THEN
-                        return_value = 1
-                        CALL internal_message( 'error', routine_name //     &
-                                ': dimension already exists in file ' //    &
-                                '(dimension "' // TRIM( dimension_name ) // &
-                                '", file "' // TRIM( file_name ) // '")!' )
-                        EXIT
-                     ENDIF
-                  ENDDO
-
-                  !-- Extend dimension list
-                  IF ( return_value == 0 )  THEN
-                     ALLOCATE( dimensions_tmp(ndims) )
-                     dimensions_tmp = files(f)%dimensions
-                     DEALLOCATE( files(f)%dimensions )
-                     ndims = ndims + 1
-                     ALLOCATE( files(f)%dimensions(ndims) )
-                     files(f)%dimensions(:ndims-1) = dimensions_tmp
-                     DEALLOCATE( dimensions_tmp )
-                  ENDIF
-               ENDIF
-
-            ENDIF
-
-            !-- Add new dimension to database
-            IF ( return_value == 0 )  files(f)%dimensions(ndims) = dimension
-
-            EXIT
-
-         ENDIF
-      ENDDO
-
-      IF ( f > nfiles )  THEN
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                                     &
-                                ': file not found (dimension "' // TRIM( dimension_name ) // &
-                                '", file "' // TRIM( file_name ) // '")!' )
-      ENDIF
-
-   ENDIF
-
-END FUNCTION dom_def_dim
+ FUNCTION dom_def_dim( file_name, dimension_name, output_type, bounds,        &
+                       values_int8, values_int16, values_int32, values_intwp, &
+                       values_real32, values_real64, values_realwp,           &
+                       mask ) RESULT( return_value )
+
+    CHARACTER(LEN=*), INTENT(IN) ::  file_name       !< name of file
+    CHARACTER(LEN=*), INTENT(IN) ::  dimension_name  !< name of dimension
+    CHARACTER(LEN=*), INTENT(IN) ::  output_type     !< data type of dimension variable in output file
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_dim'  !< name of this routine
+
+    INTEGER ::  d             !< loop index
+    INTEGER ::  f             !< loop index
+    INTEGER ::  i             !< loop index
+    INTEGER ::  j             !< loop index
+    INTEGER ::  ndims         !< number of dimensions in file
+    INTEGER ::  return_value  !< return value
+
+    INTEGER,         DIMENSION(:), INTENT(IN)           ::  bounds         !< lower and upper bound of dimension variable
+    INTEGER(KIND=1), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int8    !< values of dimension
+    INTEGER(KIND=2), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int16   !< values of dimension
+    INTEGER(KIND=4), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int32   !< values of dimension
+    INTEGER(iwp),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_intwp   !< values of dimension
+
+    LOGICAL,         DIMENSION(:), INTENT(IN), OPTIONAL ::  mask           !< mask of dimesion
+
+    REAL(KIND=4),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_real32  !< values of dimension
+    REAL(KIND=8),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_real64  !< values of dimension
+    REAL(wp),        DIMENSION(:), INTENT(IN), OPTIONAL ::  values_realwp  !< values of dimension
+
+    TYPE(dimension_type)                            ::  dimension       !< new dimension
+    TYPE(dimension_type), DIMENSION(:), ALLOCATABLE ::  dimensions_tmp  !< temporary dimension list
+
+
+    return_value = 0
+
+    CALL internal_message( 'debug', routine_name //                    &
+                           ': define dimension ' //                    &
+                           '(dimension "' // TRIM( dimension_name ) // &
+                           '", file "' // TRIM( file_name ) // '")' )
+
+    dimension%name      = TRIM( dimension_name )
+    dimension%data_type = TRIM( output_type )
+!
+!-- Check dimension bounds and allocate dimension according to bounds
+    IF ( SIZE( bounds ) == 1 )  THEN
+!
+!--    Dimension has only lower bound, which means it changes its size
+!--    during simulation.
+!--    Set length to -1 as indicator.
+       dimension%bounds(:) = bounds(1)
+       dimension%length    = -1
+
+       IF ( PRESENT( mask ) )  THEN
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                      &
+                                 ': unlimited dimensions cannot be masked ' // &
+                                 '(dimension "' // TRIM( dimension_name ) //   &
+                                 '", file "' // TRIM( file_name ) // '")!' )
+       ENDIF
+
+    ELSEIF ( SIZE( bounds ) == 2 )  THEN
+
+       dimension%bounds = bounds
+       dimension%length = bounds(2) - bounds(1) + 1
+!
+!--    Save dimension values
+       IF ( PRESENT( values_int8 ) )  THEN
+          ALLOCATE( dimension%values_int8(dimension%bounds(1):dimension%bounds(2)) )
+          IF ( SIZE( values_int8 ) == dimension%length )  THEN
+             dimension%values_int8 = values_int8
+          ELSEIF ( SIZE( values_int8 ) == 1 )  THEN
+             dimension%values_int8(:) = values_int8(1)
+          ELSE
+             return_value = 2
+          ENDIF
+       ELSEIF( PRESENT( values_int16 ) )  THEN
+          ALLOCATE( dimension%values_int16(dimension%bounds(1):dimension%bounds(2)) )
+          IF ( SIZE( values_int16 ) == dimension%length )  THEN
+             dimension%values_int16 = values_int16
+          ELSEIF ( SIZE( values_int16 ) == 1 )  THEN
+             dimension%values_int16(:) = values_int16(1)
+          ELSE
+             return_value = 2
+          ENDIF
+       ELSEIF( PRESENT( values_int32 ) )  THEN
+          ALLOCATE( dimension%values_int32(dimension%bounds(1):dimension%bounds(2)) )
+          IF ( SIZE( values_int32 ) == dimension%length )  THEN
+             dimension%values_int32 = values_int32
+          ELSEIF ( SIZE( values_int32 ) == 1 )  THEN
+             dimension%values_int32(:) = values_int32(1)
+          ELSE
+             return_value = 2
+          ENDIF
+       ELSEIF( PRESENT( values_intwp ) )  THEN
+          ALLOCATE( dimension%values_intwp(dimension%bounds(1):dimension%bounds(2)) )
+          IF ( SIZE( values_intwp ) == dimension%length )  THEN
+             dimension%values_intwp = values_intwp
+          ELSEIF ( SIZE( values_intwp ) == 1 )  THEN
+             dimension%values_intwp(:) = values_intwp(1)
+          ELSE
+             return_value = 2
+          ENDIF
+       ELSEIF( PRESENT( values_real32 ) )  THEN
+          ALLOCATE( dimension%values_real32(dimension%bounds(1):dimension%bounds(2)) )
+          IF ( SIZE( values_real32 ) == dimension%length )  THEN
+             dimension%values_real32 = values_real32
+          ELSEIF ( SIZE( values_real32 ) == 1 )  THEN
+             dimension%values_real32(:) = values_real32(1)
+          ELSE
+             return_value = 2
+          ENDIF
+       ELSEIF( PRESENT( values_real64 ) )  THEN
+          ALLOCATE( dimension%values_real64(dimension%bounds(1):dimension%bounds(2)) )
+          IF ( SIZE( values_real64 ) == dimension%length )  THEN
+             dimension%values_real64 = values_real64
+          ELSEIF ( SIZE( values_real64 ) == 1 )  THEN
+             dimension%values_real64(:) = values_real64(1)
+          ELSE
+             return_value = 2
+          ENDIF
+       ELSEIF( PRESENT( values_realwp ) )  THEN
+          ALLOCATE( dimension%values_realwp(dimension%bounds(1):dimension%bounds(2)) )
+          IF ( SIZE( values_realwp ) == dimension%length )  THEN
+             dimension%values_realwp = values_realwp
+          ELSEIF ( SIZE( values_realwp ) == 1 )  THEN
+             dimension%values_realwp(:) = values_realwp(1)
+          ELSE
+             return_value = 2
+          ENDIF
+       ELSE
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                    &
+                                 ': no values given ' //                     &
+                                 '(dimension "' // TRIM( dimension_name ) // &
+                                 '", file "' // TRIM( file_name ) // '")!' )
+       ENDIF
+
+       IF ( return_value == 2 )  THEN
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                               &
+                                 ': number of values and given bounds do not match ' // &
+                                 '(dimension "' // TRIM( dimension_name ) //            &
+                                 '", file "' // TRIM( file_name ) // '")!' )
+       ENDIF
+!
+!--    Initialize mask
+       IF ( PRESENT( mask )  .AND.  return_value == 0 )  THEN
+
+          IF ( dimension%length == SIZE( mask ) )  THEN
+
+             IF ( ALL( mask ) )  THEN
+
+                CALL internal_message( 'debug', routine_name //                              &
+                                       ': mask contains only TRUE values. Ignoring mask ' // &
+                                       '(dimension "' // TRIM( dimension_name ) //           &
+                                       '", file "' // TRIM( file_name ) // '")!' )
+
+             ELSE
+
+                dimension%is_masked = .TRUE.
+                dimension%length_mask = COUNT( mask )
+
+                ALLOCATE( dimension%mask(dimension%bounds(1):dimension%bounds(2)) )
+                ALLOCATE( dimension%masked_indices(0:dimension%length_mask-1) )
+
+                dimension%mask = mask
+!
+!--             Save masked positions and masked values
+                IF ( ALLOCATED( dimension%values_int8 ) )  THEN
+
+                   ALLOCATE( dimension%masked_values_int8(0:dimension%length_mask-1) )
+                   j = 0
+                   DO  i = dimension%bounds(1), dimension%bounds(2)
+                      IF ( dimension%mask(i) )  THEN
+                         dimension%masked_values_int8(j) = dimension%values_int8(i)
+                         dimension%masked_indices(j) = i
+                         j = j + 1
+                      ENDIF
+                   ENDDO
+
+                ELSEIF ( ALLOCATED( dimension%values_int16 ) )  THEN
+
+                   ALLOCATE( dimension%masked_values_int16(0:dimension%length_mask-1) )
+                   j = 0
+                   DO  i = dimension%bounds(1), dimension%bounds(2)
+                      IF ( dimension%mask(i) )  THEN
+                         dimension%masked_values_int16(j) = dimension%values_int16(i)
+                         dimension%masked_indices(j) = i
+                         j = j + 1
+                      ENDIF
+                   ENDDO
+
+                ELSEIF ( ALLOCATED( dimension%values_int32 ) )  THEN
+
+                   ALLOCATE( dimension%masked_values_int32(0:dimension%length_mask-1) )
+                   j = 0
+                   DO  i =dimension%bounds(1), dimension%bounds(2)
+                      IF ( dimension%mask(i) )  THEN
+                         dimension%masked_values_int32(j) = dimension%values_int32(i)
+                         dimension%masked_indices(j) = i
+                         j = j + 1
+                      ENDIF
+                   ENDDO
+
+                ELSEIF ( ALLOCATED( dimension%values_intwp ) )  THEN
+
+                   ALLOCATE( dimension%masked_values_intwp(0:dimension%length_mask-1) )
+                   j = 0
+                   DO  i = dimension%bounds(1), dimension%bounds(2)
+                      IF ( dimension%mask(i) )  THEN
+                         dimension%masked_values_intwp(j) = dimension%values_intwp(i)
+                         dimension%masked_indices(j) = i
+                         j = j + 1
+                      ENDIF
+                   ENDDO
+
+                ELSEIF ( ALLOCATED( dimension%values_real32 ) )  THEN
+
+                   ALLOCATE( dimension%masked_values_real32(0:dimension%length_mask-1) )
+                   j = 0
+                   DO  i = dimension%bounds(1), dimension%bounds(2)
+                      IF ( dimension%mask(i) )  THEN
+                         dimension%masked_values_real32(j) = dimension%values_real32(i)
+                         dimension%masked_indices(j) = i
+                         j = j + 1
+                      ENDIF
+                   ENDDO
+
+                ELSEIF ( ALLOCATED(dimension%values_real64) )  THEN
+
+                   ALLOCATE( dimension%masked_values_real64(0:dimension%length_mask-1) )
+                   j = 0
+                   DO  i = dimension%bounds(1), dimension%bounds(2)
+                      IF ( dimension%mask(i) )  THEN
+                         dimension%masked_values_real64(j) = dimension%values_real64(i)
+                         dimension%masked_indices(j) = i
+                         j = j + 1
+                      ENDIF
+                   ENDDO
+
+                ELSEIF ( ALLOCATED(dimension%values_realwp) )  THEN
+
+                   ALLOCATE( dimension%masked_values_realwp(0:dimension%length_mask-1) )
+                   j = 0
+                   DO  i = dimension%bounds(1), dimension%bounds(2)
+                      IF ( dimension%mask(i) )  THEN
+                         dimension%masked_values_realwp(j) = dimension%values_realwp(i)
+                         dimension%masked_indices(j) = i
+                         j = j + 1
+                      ENDIF
+                   ENDDO
+
+                ENDIF
+
+             ENDIF  ! if not all mask = true
+
+          ELSE
+             return_value = 1
+             CALL internal_message( 'error', routine_name //                           &
+                                    ': size of mask and given bounds do not match ' // &
+                                    '(dimension "' // TRIM( dimension_name ) //        &
+                                    '", file "' // TRIM( file_name ) // '")!' )
+          ENDIF
+
+       ENDIF
+
+    ELSE
+
+       return_value = 1
+       CALL internal_message( 'error', routine_name //                                       &
+                              ': at least one but no more than two bounds must be given ' // &
+                              '(dimension "' // TRIM( dimension_name ) //                    &
+                              '", file "' // TRIM( file_name ) // '")!' )
+
+    ENDIF
+!
+!-- Add dimension to database
+    IF ( return_value == 0 )  THEN
+
+       DO  f = 1, nfiles
+
+          IF ( TRIM( file_name ) == files(f)%name )  THEN
+
+             IF ( files(f)%is_init )  THEN
+
+                return_value = 1
+                CALL internal_message( 'error', routine_name //                      &
+                                       ': file already initialized. ' //             &
+                                       'No further dimension definition allowed ' // &
+                                       '(dimension "' // TRIM( dimension_name ) //   &
+                                       '", file "' // TRIM( file_name ) // '")!' )
+                EXIT
+
+             ELSEIF ( .NOT. ALLOCATED( files(f)%dimensions ) )  THEN
+
+                ndims = 1
+                ALLOCATE( files(f)%dimensions(ndims) )
+
+             ELSE
+!
+!--             Check if any variable of the same name as the new dimension is already defined
+                IF ( ALLOCATED( files(f)%variables ) )  THEN
+                   DO  i = 1, SIZE( files(f)%variables )
+                      IF ( files(f)%variables(i)%name == dimension%name )  THEN
+                         return_value = 1
+                         CALL internal_message( 'error', routine_name //                    &
+                                 ': file already has a variable of this name defined. ' //  &
+                                 'Defining a dimension of the same name is not allowed ' // &
+                                 '(dimension "' // TRIM( dimension_name ) //                &
+                                 '", file "' // TRIM( file_name ) // '")!' )
+                         EXIT
+                      ENDIF
+                   ENDDO
+                ENDIF
+
+                IF ( return_value == 0 )  THEN
+!
+!--                Check if dimension already exists in file
+                   ndims = SIZE( files(f)%dimensions )
+
+                   DO  d = 1, ndims
+                      IF ( files(f)%dimensions(d)%name == dimension%name )  THEN
+                         return_value = 1
+                         CALL internal_message( 'error', routine_name //     &
+                                 ': dimension already exists in file ' //    &
+                                 '(dimension "' // TRIM( dimension_name ) // &
+                                 '", file "' // TRIM( file_name ) // '")!' )
+                         EXIT
+                      ENDIF
+                   ENDDO
+!
+!--                Extend dimension list
+                   IF ( return_value == 0 )  THEN
+                      ALLOCATE( dimensions_tmp(ndims) )
+                      dimensions_tmp = files(f)%dimensions
+                      DEALLOCATE( files(f)%dimensions )
+                      ndims = ndims + 1
+                      ALLOCATE( files(f)%dimensions(ndims) )
+                      files(f)%dimensions(:ndims-1) = dimensions_tmp
+                      DEALLOCATE( dimensions_tmp )
+                   ENDIF
+                ENDIF
+
+             ENDIF
+!
+!--          Add new dimension to database
+             IF ( return_value == 0 )  files(f)%dimensions(ndims) = dimension
+
+             EXIT
+
+          ENDIF
+       ENDDO
+
+       IF ( f > nfiles )  THEN
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                                     &
+                                 ': file not found (dimension "' // TRIM( dimension_name ) // &
+                                 '", file "' // TRIM( file_name ) // '")!' )
+       ENDIF
+
+    ENDIF
+
+ END FUNCTION dom_def_dim
 
 !--------------------------------------------------------------------------------------------------!
